Declare Sub BMPToFunction (byval Basecolor as UInteger, Byval BMPFileName as String, Byval FunctionName as String="")

Public Sub BMPToFunction (byval Basecolor as UInteger, Byval BMPFileName as String, Byval FunctionName as String="")
    If Dir(BMPFilename)="" Then Exit Sub
    
    DIM F AS INTEGER=FREEFILE
    Dim BMPHeader as String*2
    Dim SizeX     as UInteger
    Dim SizeY     as UInteger
    
    OPEN BMPFileName FOR BINARY ACCESS READ AS #F
        GET #F,   , BMPHeader
        If BMPHeader<>"BM" Then
            Close #F
            Exit Sub
        End If
        
        GET #F, 19, SizeX
        GET #F,   , SizeY
    Close #F
    
    ?"Start"
    Dim BMPImage     as any ptr=ImageCreate(SizeX,SizeY)
    BLoad BMPFileName,BMPImage
    
    Dim BMPBaseColor as UInteger'=BaseColor(BMPImage)
    BMPBaseColor=Basecolor'&hFFFF00FF
    ?"BaseColor is Hex:"+Hex(BMPBaseColor,8)
    
    Dim ReadColor     as UInteger
    Dim IMG_width     as UInteger=Peek(UInteger,BMPImage+8)
    Dim IMG_height    as UInteger=Peek(UInteger,BMPImage+12)
    Dim IMG_Pitch     as UInteger=Peek(UInteger,BMPImage+16)
    Dim APos          as UInteger
    Dim APosS         as String
    
    Dim NextLine      as String
    Dim NextLineCount as Integer
    
    If Trim(FunctionName)="" Then FunctionName=BMPFileName
    
    Open FunctionName+".bas" for output as #F

    Print #F,"'' Created with : BMP2FUNCTION by EternalPain"
    Print #F,"''"
    Print #F,"'' BMPFilename  : "+BMPFileName+" Width: "+str(IMG_width)+" Height: "+Str(IMG_height)
    Print #F,"'' Functionname : "+FunctionName
    Print #F,"Function "+FunctionName+" as any ptr"
    Print #F,"  Dim IMGBuffer as UInteger PTR=ImageCreate("+str(IMG_width)+","+str(IMG_height)+",&h"+hex(BMPBaseColor,8)+")"

    
    for y as integer=0 to IMG_height-1
    for x as integer=0 to IMG_width-1
        
        APos=X+(Y*(IMG_Pitch/4))+8
        APosS="000000"
        Mid(APosS,7-(Len(Str(APos))),Len(Str(APos))) = Str(Apos)
        ReadColor=Peek(UInteger,BMPImage+32+(X*4)+(Y*IMG_Pitch))
        
        If ReadColor<>BMPBaseColor Then 
            If NextLineCount=0 Then NextLine += "  "
            NextLine += "IMGBuffer["+APosS+"]=&h"+hex(ReadColor,8)
            NextLineCount += 1
            If NextLineCount < 3 Then NextLine += " : "
        End If
        
        If NextLineCount=3 Then
            Print #F,NextLine
            NextLineCount = 0
            NextLine=""
        End If
    next x
    next y
    
    If NextLineCount>0 Then Print #F,NextLine

    Print #F,"  Return IMGBuffer"
    Print #F,"/'"
    Print #F,chr(34)+"---"+chr(34,32)+FunctionName+chr(32,34)+"---"+chr(34)
    Print #F,"'/"
    Print #F,"End Function"
    Close #F
    ?"Ready."
    ?"Function saved as "+FunctionName+".bas"
End Sub
/'
"-------------------------------------------------------------------------------"
'/    
        

screen 19,32
BMPToFunction (&hFFFF00FF,"00.bmp","Hangman_1_GRX")
BMPToFunction (&hFFFF00FF,"01.bmp","Hangman_2_GRX")
BMPToFunction (&hFFFF00FF,"02.bmp","Hangman_3_GRX")
BMPToFunction (&hFFFF00FF,"03.bmp","Hangman_4_GRX")
BMPToFunction (&hFFFF00FF,"04.bmp","Hangman_5_GRX")
BMPToFunction (&hFFFF00FF,"05.bmp","Hangman_6_GRX")





sleep


    

